Index: mythtv/libs/libmythhdhomerun/hdhomerun_device.h
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_device.h	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_device.h	(working copy)
@@ -90,8 +90,8 @@
 extern LIBTYPE uint32_t hdhomerun_device_get_device_ip_requested(struct hdhomerun_device_t *hd);
 extern LIBTYPE unsigned int hdhomerun_device_get_tuner(struct hdhomerun_device_t *hd);
 
-extern LIBTYPE int hdhomerun_device_set_device(struct hdhomerun_device_t *hd, uint32_t device_id, uint32_t device_ip);
-extern LIBTYPE int hdhomerun_device_set_tuner(struct hdhomerun_device_t *hd, unsigned int tuner);
+extern LIBTYPE void hdhomerun_device_set_device(struct hdhomerun_device_t *hd, uint32_t device_id, uint32_t device_ip);
+extern LIBTYPE void hdhomerun_device_set_tuner(struct hdhomerun_device_t *hd, unsigned int tuner);
 extern LIBTYPE int hdhomerun_device_set_tuner_from_str(struct hdhomerun_device_t *hd, const char *tuner_str);
 
 /*
@@ -148,9 +148,10 @@
 extern LIBTYPE int hdhomerun_device_set_tuner_filter_by_array(struct hdhomerun_device_t *hd, unsigned char filter_array[0x2000]);
 extern LIBTYPE int hdhomerun_device_set_tuner_program(struct hdhomerun_device_t *hd, const char *program);
 extern LIBTYPE int hdhomerun_device_set_tuner_target(struct hdhomerun_device_t *hd, const char *target);
+extern LIBTYPE int hdhomerun_device_set_tuner_target_to_local_protocol(struct hdhomerun_device_t *hd, const char *protocol);
+extern LIBTYPE int hdhomerun_device_set_tuner_target_to_local(struct hdhomerun_device_t *hd);
 extern LIBTYPE int hdhomerun_device_set_ir_target(struct hdhomerun_device_t *hd, const char *target);
 extern LIBTYPE int hdhomerun_device_set_lineup_location(struct hdhomerun_device_t *hd, const char *location);
-extern LIBTYPE int hdhomerun_device_set_sys_dvbc_modulation(struct hdhomerun_device_t *hd, const char *modulation_list);
 
 /*
  * Get/set a named control variable on the device.
@@ -223,6 +224,7 @@
  * The hdhomerun_device_stream_stop function tells the device to stop streaming data.
  */
 extern LIBTYPE int hdhomerun_device_stream_start(struct hdhomerun_device_t *hd);
+extern LIBTYPE int hdhomerun_device_stream_refresh_target(struct hdhomerun_device_t *hd);
 extern LIBTYPE uint8_t *hdhomerun_device_stream_recv(struct hdhomerun_device_t *hd, size_t max_size, size_t *pactual_size);
 extern LIBTYPE void hdhomerun_device_stream_flush(struct hdhomerun_device_t *hd);
 extern LIBTYPE void hdhomerun_device_stream_stop(struct hdhomerun_device_t *hd);
@@ -236,6 +238,17 @@
 extern LIBTYPE uint8_t hdhomerun_device_channelscan_get_progress(struct hdhomerun_device_t *hd);
 
 /*
+ * Check that the device is running the recommended firmware.
+ *
+ * uint32_t features: Reserved for future use. Set to zero.
+ *
+ * Returns 1 if the firmware meets the minimum requriements for all operations.
+ * Returns 0 if th firmware does not meet the minimum requriements for all operations.
+ * Returns -1 if an error occurs.
+ */
+extern LIBTYPE int hdhomerun_device_firmware_version_check(struct hdhomerun_device_t *hd, uint32_t features);
+
+/*
  * Upload new firmware to the device.
  *
  * FILE *upgrade_file: File pointer to read from. The file must have been opened in binary mode for reading.
Index: mythtv/libs/libmythhdhomerun/hdhomerun_control.c
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_control.c	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_control.c	(working copy)
@@ -1,7 +1,7 @@
 /*
  * hdhomerun_control.c
  *
- * Copyright © 2006-2010 Silicondust USA Inc. <www.silicondust.com>.
+ * Copyright © 2006 Silicondust USA Inc. <www.silicondust.com>.
  *
  * This library is free software; you can redistribute it and/or 
  * modify it under the terms of the GNU Lesser General Public
@@ -32,9 +32,8 @@
 
 #include "hdhomerun.h"
 
-#define HDHOMERUN_CONTROL_CONNECT_TIMEOUT 2500
-#define HDHOMERUN_CONTROL_SEND_TIMEOUT 2500
-#define HDHOMERUN_CONTROL_RECV_TIMEOUT 2500
+#define HDHOMERUN_CONTROL_SEND_TIMEOUT 5000
+#define HDHOMERUN_CONTROL_RECV_TIMEOUT 5000
 #define HDHOMERUN_CONTROL_UPGRADE_TIMEOUT 20000
 
 struct hdhomerun_control_sock_t {
@@ -50,12 +49,12 @@
 
 static void hdhomerun_control_close_sock(struct hdhomerun_control_sock_t *cs)
 {
-	if (cs->sock == HDHOMERUN_SOCK_INVALID) {
+	if (cs->sock == -1) {
 		return;
 	}
 
-	hdhomerun_sock_destroy(cs->sock);
-	cs->sock = HDHOMERUN_SOCK_INVALID;
+	close(cs->sock);
+	cs->sock = -1;
 }
 
 void hdhomerun_control_set_device(struct hdhomerun_control_sock_t *cs, uint32_t device_id, uint32_t device_ip)
@@ -77,7 +76,7 @@
 	}
 
 	cs->dbg = dbg;
-	cs->sock = HDHOMERUN_SOCK_INVALID;
+	cs->sock = -1;
 	hdhomerun_control_set_device(cs, device_id, device_ip);
 
 	return cs;
@@ -91,7 +90,7 @@
 
 static bool_t hdhomerun_control_connect_sock(struct hdhomerun_control_sock_t *cs)
 {
-	if (cs->sock != HDHOMERUN_SOCK_INVALID) {
+	if (cs->sock != -1) {
 		return TRUE;
 	}
 
@@ -99,10 +98,6 @@
 		hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_connect_sock: no device specified\n");
 		return FALSE;
 	}
-	if (hdhomerun_discover_is_ip_multicast(cs->desired_device_ip)) {
-		hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_connect_sock: cannot use multicast ip address for device operations\n");
-		return FALSE;
-	}
 
 	/* Find device. */
 	struct hdhomerun_discover_device_t result;
@@ -114,15 +109,24 @@
 	cs->actual_device_id = result.device_id;
 
 	/* Create socket. */
-	cs->sock = hdhomerun_sock_create_tcp();
-	if (cs->sock == HDHOMERUN_SOCK_INVALID) {
-		hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_connect_sock: failed to create socket (%d)\n", hdhomerun_sock_getlasterror());
+	cs->sock = (int)socket(AF_INET, SOCK_STREAM, 0);
+	if (cs->sock == -1) {
+		hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_connect_sock: failed to create socket (%d)\n", sock_getlasterror);
 		return FALSE;
 	}
 
+	/* Set timeouts. */
+	setsocktimeout(cs->sock, SOL_SOCKET, SO_SNDTIMEO, HDHOMERUN_CONTROL_SEND_TIMEOUT);
+	setsocktimeout(cs->sock, SOL_SOCKET, SO_RCVTIMEO, HDHOMERUN_CONTROL_RECV_TIMEOUT);
+
 	/* Initiate connection. */
-	if (!hdhomerun_sock_connect(cs->sock, cs->actual_device_ip, HDHOMERUN_CONTROL_TCP_PORT, HDHOMERUN_CONTROL_CONNECT_TIMEOUT)) {
-		hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_connect_sock: failed to connect (%d)\n", hdhomerun_sock_getlasterror());
+	struct sockaddr_in sock_addr;
+	memset(&sock_addr, 0, sizeof(sock_addr));
+	sock_addr.sin_family = AF_INET;
+	sock_addr.sin_addr.s_addr = htonl(cs->actual_device_ip);
+	sock_addr.sin_port = htons(HDHOMERUN_CONTROL_TCP_PORT);
+	if (connect(cs->sock, (struct sockaddr *)&sock_addr, sizeof(sock_addr)) != 0) {
+		hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_connect_sock: failed to connect (%d)\n", sock_getlasterror);
 		hdhomerun_control_close_sock(cs);
 		return FALSE;
 	}
@@ -168,58 +172,76 @@
 		return 0;
 	}
 
-	uint32_t addr = hdhomerun_sock_getsockname_addr(cs->sock);
-	if (addr == 0) {
-		hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_get_local_addr: getsockname failed (%d)\n", hdhomerun_sock_getlasterror());
+	struct sockaddr_in sock_addr;
+	socklen_t sockaddr_size = sizeof(sock_addr);
+	if (getsockname(cs->sock, (struct sockaddr*)&sock_addr, &sockaddr_size) != 0) {
+		hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_get_local_addr: getsockname failed (%d)\n", sock_getlasterror);
 		return 0;
 	}
 
-	return addr;
+	return ntohl(sock_addr.sin_addr.s_addr);
 }
 
-static bool_t hdhomerun_control_send_sock(struct hdhomerun_control_sock_t *cs, struct hdhomerun_pkt_t *tx_pkt)
+static int hdhomerun_control_send_sock(struct hdhomerun_control_sock_t *cs, struct hdhomerun_pkt_t *tx_pkt)
 {
-	if (!hdhomerun_sock_send(cs->sock, tx_pkt->start, tx_pkt->end - tx_pkt->start, HDHOMERUN_CONTROL_SEND_TIMEOUT)) {
-		hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_send_sock: send failed (%d)\n", hdhomerun_sock_getlasterror());
+	int length = (int)(tx_pkt->end - tx_pkt->start);
+	if (send(cs->sock, (char *)tx_pkt->start, (int)length, 0) != length) {
+		hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_send_sock: send failed (%d)\n", sock_getlasterror);
 		hdhomerun_control_close_sock(cs);
-		return FALSE;
+		return -1;
 	}
 
-	return TRUE;
+	return 1;
 }
 
-static bool_t hdhomerun_control_recv_sock(struct hdhomerun_control_sock_t *cs, struct hdhomerun_pkt_t *rx_pkt, uint16_t *ptype, uint64_t recv_timeout)
+static int hdhomerun_control_recv_sock(struct hdhomerun_control_sock_t *cs, struct hdhomerun_pkt_t *rx_pkt, uint16_t *ptype, uint64_t recv_timeout)
 {
 	uint64_t stop_time = getcurrenttime() + recv_timeout;
 	hdhomerun_pkt_reset(rx_pkt);
 
-	while (1) {
-		uint64_t current_time = getcurrenttime();
-		if (current_time >= stop_time) {
-			hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_recv_sock: timeout\n");
+	while (getcurrenttime() < stop_time) {
+		struct timeval t;
+		t.tv_sec = 0;
+		t.tv_usec = 250000;
+	
+		fd_set readfds;
+		FD_ZERO(&readfds);
+		FD_SET(cs->sock, &readfds);
+	
+		if (select(cs->sock+1, &readfds, NULL, NULL, &t) < 0) {
+			hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_recv_sock: select failed (%d)\n", sock_getlasterror);
 			hdhomerun_control_close_sock(cs);
-			return FALSE;
+			return -1;
 		}
-
-		size_t length = rx_pkt->limit - rx_pkt->end;
-		if (!hdhomerun_sock_recv(cs->sock, rx_pkt->end, &length, stop_time - current_time)) {
-			hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_recv_sock: recv failed (%d)\n", hdhomerun_sock_getlasterror());
+	
+		if (!FD_ISSET(cs->sock, &readfds)) {
+			continue;
+		}
+	
+		int rx_length = recv(cs->sock, (char *)rx_pkt->end, (int)(rx_pkt->limit - rx_pkt->end), 0);
+		if (rx_length <= 0) {
+			hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_recv_sock: recv failed (%d)\n", sock_getlasterror);
 			hdhomerun_control_close_sock(cs);
-			return FALSE;
+			return -1;
 		}
+		rx_pkt->end += rx_length;
 
-		rx_pkt->end += length;
-
 		int ret = hdhomerun_pkt_open_frame(rx_pkt, ptype);
 		if (ret < 0) {
 			hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_recv_sock: frame error\n");
 			hdhomerun_control_close_sock(cs);
-			return FALSE;
+			return -1;
 		}
-		if (ret > 0) {
-			return TRUE;
+		if (ret == 0) {
+			continue;
 		}
+
+		return 1;
 	}
+
+	hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_recv_sock: timeout\n");
+	hdhomerun_control_close_sock(cs);
+	return -1;
 }
 
 static int hdhomerun_control_send_recv_internal(struct hdhomerun_control_sock_t *cs, struct hdhomerun_pkt_t *tx_pkt, struct hdhomerun_pkt_t *rx_pkt, uint16_t type, uint64_t recv_timeout)
@@ -228,14 +250,14 @@
 
 	int i;
 	for (i = 0; i < 2; i++) {
-		if (cs->sock == HDHOMERUN_SOCK_INVALID) {
+		if (cs->sock == -1) {
 			if (!hdhomerun_control_connect_sock(cs)) {
 				hdhomerun_debug_printf(cs->dbg, "hdhomerun_control_send_recv: connect failed\n");
 				return -1;
 			}
 		}
 
-		if (!hdhomerun_control_send_sock(cs, tx_pkt)) {
+		if (hdhomerun_control_send_sock(cs, tx_pkt) < 0) {
 			continue;
 		}
 		if (!rx_pkt) {
@@ -243,7 +265,7 @@
 		}
 
 		uint16_t rsp_type;
-		if (!hdhomerun_control_recv_sock(cs, rx_pkt, &rsp_type, recv_timeout)) {
+		if (hdhomerun_control_recv_sock(cs, rx_pkt, &rsp_type, recv_timeout) < 0) {
 			continue;
 		}
 		if (rsp_type != type + 1) {
@@ -279,7 +301,7 @@
 	}
 	hdhomerun_pkt_write_u8(tx_pkt, HDHOMERUN_TAG_GETSET_NAME);
 	hdhomerun_pkt_write_var_length(tx_pkt, name_len);
-	hdhomerun_pkt_write_mem(tx_pkt, (void *)name, name_len);
+	hdhomerun_pkt_write_mem(tx_pkt, (const void *)name, name_len);
 
 	if (value) {
 		int value_len = (int)strlen(value) + 1;
@@ -289,7 +311,7 @@
 		}
 		hdhomerun_pkt_write_u8(tx_pkt, HDHOMERUN_TAG_GETSET_VALUE);
 		hdhomerun_pkt_write_var_length(tx_pkt, value_len);
-		hdhomerun_pkt_write_mem(tx_pkt, (void *)value, value_len);
+		hdhomerun_pkt_write_mem(tx_pkt, (const void *)value, value_len);
 	}
 
 	if (lockkey != 0) {
